/*
        TextArea1.h 1.1 for X11R6 & GNU C Compiler

        Copyright (C) 1998, 1999 Syllabub
        Maroontress Fast Software.
*/

void GetSelectedRegion(SylTextArea *txt, SylLocation *left,
		       SylLocation *right);
unsigned int SizeOfRegion(SylTextArea *txt, SylLocation *left,
			  SylLocation *right);
void CopyRegionToWCString(SylTextArea *txt, SylLocation *left,
			  SylLocation *right, wchar_t *wcs);
void DeleteRegion(SylTextArea *txt, SylLocation *left,
		  SylLocation *right); /* 1999-10-09: added */
void SetSelectionOwner(SylTextArea *txt, Time tm);
void ResetSelectionOwner(SylTextArea *txt);

int IsEqualSylLocation(SylLocation *p, SylLocation *q);
SylLocation LocationOfDestination(SylTextArea *, SylLocation *, int);
SylLocation LocationPointed(SylTextArea *txt, int w, int h);

void BackSpace(SylTextArea *txt, Time tm);
void Delete(SylTextArea *txt, Time tm);
void YankLine(SylTextArea *txt, Time tm);
void YankLineWithShift(SylTextArea *txt, Time tm);
void KillLine(SylTextArea *txt, Time tm);

void CursorBeginingOfLine(SylTextArea *txt, Time tm);
void CursorBeginingOfLineWithShift(SylTextArea *txt, Time tm);
void CursorEndOfLine(SylTextArea *txt, Time tm);
void CursorEndOfLineWithShift(SylTextArea *txt, Time tm);

void CursorNextWord(SylTextArea *txt, Time tm);
void CursorNextWordWithShift(SylTextArea *txt, Time tm);
void CursorPrevWord(SylTextArea *txt, Time tm);
void CursorPrevWordWithShift(SylTextArea *txt, Time tm);

void CursorLeft(SylTextArea *txt, Time tm);
void CursorLeftWithShift(SylTextArea *txt, Time tm);
void CursorRight(SylTextArea *txt, Time tm);
void CursorRightWithShift(SylTextArea *txt, Time tm);

void InsertChar(SylTextArea *txt, wchar_t c);
void LineFeed(SylTextArea *txt, Time tm);

void CursorLeftEdge(SylTextArea *txt, Time tm);
void CursorLeftEdgeWithShift(SylTextArea *txt, Time tm);
void CursorRightEdge(SylTextArea *txt, Time tm);
void CursorRightEdgeWithShift(SylTextArea *txt, Time tm);

int RowsAfterMovingVertically(SylTextArea *txt); /* 1999-10-09: added */

void CursorUp(SylTextArea *txt, Time tm);
void CursorUpWithShift(SylTextArea *txt, Time tm);
void CursorDown(SylTextArea *txt, Time tm);
void CursorDownWithShift(SylTextArea *txt, Time tm);

void GrabbedCursorUp(SylTextArea *txt);
void GrabbedCursorDown(SylTextArea *txt);

void SetFocusToNextField(SylTextArea *txt, Time tm);
void SetFocusToPrevField(SylTextArea *txt, Time tm);

void ScrollUp(SylTextArea *txt, Time tm);
void ScrollDown(SylTextArea *txt, Time tm);

#define TextAreaTextWidth(t) ((t)->width - ((t)->sidemargin) * 2)
